/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_PulmonaryVeinModifiers;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_PulmonaryVeinModifiers;
import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumChestCardiacSNOMEDMap;

/**
 * This class represents PulmonaryVeinModifiers CID12219
 */
public class PulmonaryVeinModifiers_CID12219 {

	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	/**
	 * Instantiates a new PulmonaryVeinModifiers_CID12219 Template 
	 */
	public PulmonaryVeinModifiers_CID12219()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}
	
	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}
	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumPulmonaryVeinModifiers Object of EnumCM_PulmonaryVeinModifiers represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_PulmonaryVeinModifiers enumPulmonaryVeinModifiers)
	{
		switch(enumPulmonaryVeinModifiers) 
		{
		case RIGHT_UPPER_SEGMENT: this.strCodeValue =EnumCV_PulmonaryVeinModifiers.RIGHT_UPPER_SEGMENT_R_404A0.getValue(); break;
		case RIGHT_LOWER_SEGMENT: this.strCodeValue =EnumCV_PulmonaryVeinModifiers.RIGHT_LOWER_SEGMENT_R_4049E.getValue(); break;
		case LEFT_UPPER_SEGMENT: this.strCodeValue =EnumCV_PulmonaryVeinModifiers.LEFT_UPPER_SEGMENT_R_40491.getValue(); break;
		case LEFT_LOWER_SEGMENT: this.strCodeValue =EnumCV_PulmonaryVeinModifiers.LEFT_LOWER_SEGMENT_R_4214B.getValue(); break;
		}
	}

	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumPulmonaryVeinModifiers Object of EnumCM_PulmonaryVeinModifiers represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_PulmonaryVeinModifiers enumPulmonaryVeinModifiers)
	{
		switch(enumPulmonaryVeinModifiers)
		{
		case RIGHT_UPPER_SEGMENT : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.RIGHT_UPPER_SEGMENT.getSNOMEDCTID(); break;
		case RIGHT_LOWER_SEGMENT : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.RIGHT_LOWER_SEGMENT.getSNOMEDCTID(); break;
		case LEFT_UPPER_SEGMENT : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.LEFT_UPPER_SEGMENT.getSNOMEDCTID(); break;
		case LEFT_LOWER_SEGMENT : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.LEFT_LOWER_SEGMENT.getSNOMEDCTID(); break;
		}
	}

	/**
	 * Sets the value for PulmonaryVeinModifiers
	 * @param enumPulmonaryVeinModifiers Object of EnumCM_PulmonaryVeinModifiers.
	 */
	public void setPulmonaryVeinModifiers(EnumCM_PulmonaryVeinModifiers enumPulmonaryVeinModifiers)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumPulmonaryVeinModifiers.getValue();
		this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.SRT.getValue();
		
		/**
		 * set code Value
		 */
		setCodeValue(enumPulmonaryVeinModifiers);

		/**
		 * set SNOMED-CT ID
		 */
		setSNOMEDCTID(enumPulmonaryVeinModifiers);
	}
}
